    001    /* ========================================================================
    002     * JCommon : a free general purpose class library for the Java(tm) platform
    003     * ========================================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jcommon/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ---------------------
    028     * DateCellRenderer.java
    029     * ---------------------
    030     * (C) Copyright 2003, 2004, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: DateCellRenderer.java,v 1.5 2005/11/03 09:26:22 mungady Exp $
    036     *
    037     * Changes (from 26-Oct-2001)
    038     * --------------------------
    039     * 24-Jul-2003 : Version 1 (DG);
    040     *
    041     */
    042
    043    package org.jfree.ui;
    044
    045    import java.awt.Component;
    046    import java.text.DateFormat;
    047
    048    import javax.swing.JTable;
    049    import javax.swing.SwingConstants;
    050    import javax.swing.table.DefaultTableCellRenderer;
    051
    052    /**
    053     * A table cell renderer that formats dates.
    054     *
    055     * @author David Gilbert
    056     */
    057    public class DateCellRenderer extends DefaultTableCellRenderer {
    058
    059        /** The formatter. */
    060        private DateFormat formatter;
    061
    062        /**
    063         * Default constructor.
    064         */
    065        public DateCellRenderer() {
    066            this(DateFormat.getDateTimeInstance());
    067        }
    068
    069        /**
    070         * Creates a new renderer.
    071         *
    072         * @param formatter  the formatter.
    073         */
    074        public DateCellRenderer(final DateFormat formatter) {
    075            super();
    076            this.formatter = formatter;
    077            setHorizontalAlignment(SwingConstants.CENTER);
    078        }
    079
    080        /**
    081         * Returns itself as the renderer. Supports the TableCellRenderer interface.
    082         *
    083         * @param table  the table.
    084         * @param value  the data to be rendered.
    085         * @param isSelected  a boolean that indicates whether or not the cell is
    086         *                    selected.
    087         * @param hasFocus  a boolean that indicates whether or not the cell has
    088         *                  the focus.
    089         * @param row  the (zero-based) row index.
    090         * @param column  the (zero-based) column index.
    091         *
    092         * @return the component that can render the contents of the cell.
    093         */
    094        public Component getTableCellRendererComponent(final JTable table,
    095                final Object value, final boolean isSelected,
    096                final boolean hasFocus, final int row, final int column) {
    097
    098            setFont(null);
    099            setText(this.formatter.format(value));
    100            if (isSelected) {
    101                setBackground(table.getSelectionBackground());
    102            }
    103            else {
    104                setBackground(null);
    105            }
    106            return this;
    107        }
    108
    109    }